#
# spec file for package ghc-rhine
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%global pkg_name rhine
Name:           ghc-%{pkg_name}
Version:        0.4.0.1
Release:        3.12
Summary:        Functional Reactive Programming with type-level clocks
License:        BSD-3-Clause
Group:          Development/Libraries/Haskell
URL:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  chrpath
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-dunai-devel
BuildRequires:  ghc-free-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-time-devel
BuildRequires:  ghc-transformers-devel

%description
Rhine is a library for synchronous and asynchronous Functional Reactive
Programming (FRP). It separates the aspects of clocking, scheduling and
resampling from each other, and ensures clock-safety on the type level.
Signal processing units can be annotated by clocks, which hold the information
when data will be input, processed and output. Different components of the
signal network will become active at different times, or work at different
rates. To schedule the components and allow them to communicate, several
standard scheduling and resampling solutions are implemented. Own schedules and
resampling buffers can be implemented in a reusable fashion. A (synchronous)
program outputting "Hello World!" every tenth of a second looks like this:
'flow $ arrMSync_ (putStrLn "Hello World!") '' (waitClock :: Millisecond 100)'.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Haskell
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}

%build
%ghc_lib_build

%install
%ghc_lib_install
%ghc_fix_rpath %{pkg_name}-%{version}

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%license LICENSE
%{_bindir}/Demonstration
%{_bindir}/HelloWorld

%files devel -f %{name}-devel.files
%doc README.md

%changelog
* Tue Jul 10 2018 psimons@suse.com
- Add rhine at version 0.4.0.1.
